<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

mixin propKB(name)
  li #[kbd.text-info= name] :
    |
    |
    block

Example(title='Markdown Widget' :maxState="1")
  template(v-slot:description)
    h5 This is a Markdown Widget Example
    p Click on the #[em animate] to toggle edit mode.
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    div #[strong Properties:]
      ul
        +prop("value") the current live value
        +prop("inEdit") enter/exit edit mode
        +prop("maxLength") set max character length

    div #[strong Data:]
      ul
        +prop("editValue") edit mode currently selected value

    div #[strong Signals:]
      ul
        +prop("edit") emitted whenever editValue is changed (with editValue new content)

    div #[strong Slots:]
      ul
        +prop("buttons") to add more buttons on the right of "Edit/Preview" button in the header
        +prop("toolbar-extra") to add more buttons on the right of Editor Toolbar

    div #[strong Editor Shortcuts:]
      ul
        +propKB("Ctrl+B") Bold selected text
        +propKB("Ctrl+I") Italic selected text
        +propKB("Ctrl+L") List selected text
        +propKB("Ctrl+K") Link selected text
        +propKB("Ctrl+Z") Undo
        +propKB("Ctrl+Shift+Z") Redo
        +propKB("Ctrl+Enter") Switch Edit/Preview mode

  template(v-slot:code)
    template(v-pre).
      .row
        BaseMarkdownWidget(:inEdit='state !== 0' :maxLength="3000"
          value='### Markdown Widget Test (this is a h3)\n' +
            '\n' +
            'Paragraphs are separated by a blank line.\n' +
            '\n' +
            '2nd paragraph. *Italic*, **bold**, ~~strikethrough~~ and `monospace`. Itemized lists look like:\n' +
            '\n' +
            '* this is one\n' +
            '* this is two\n' +
            '* this is three\n' +
            '\n' +
            'Here is a numbered list:\n' +
            '  1. first item\n' +
            '  2. second item\n' +
            '  3. third item\n' +
            '\n' +
            'Here is a task list:\n' +
            '- [X] first item\n' +
            '- [ ] second item\n' +
            '- [ ] third item\n' +
            '\n' +
            'Here is a link to [a website](http://foo.bar)\n' +
            '\n' +
            'This how code block looks like:\n' +
            '```\n' +
            '// Some comments\n' +
            'line 1 of code\n' +
            'line 2 of code\n' +
            'line 3 of code\n' +
            '```\n' +
            'This how quote looks like:\n' +
            '\n' +
            '> Block quotes are\n' +
            '> written like so.\n' +
            '>\n' +
            '> > They can span multiple paragraphs,\n' +
            '> > if you like.\n' +
            '\n' +
            'You can also insert tables! Look:\n' +
            '| Name | Surname | City |\n' +
            '| ------ | ------ | ------ |\n' +
            '| Carlos | Santana | Tijuana |\n' +
            '| Eric | Clapton | Ripley |\n' +
            '\n' +
            '\n' +
            'Unicode is supported. ☺\n' +
            '\n' +
            'Also emojis are supported! :+1: :tada: [here a complete list](https://github.com/caiyongji/emoji-list)')
</template>
<script>
import { BaseMarkdownWidget } from "../src";
import Example from "./AppExample.vue";

export default {
  name: "ExampleMarkdownWidget",
  components: { Example, BaseMarkdownWidget }
};

</script>
